spot 2.2.2

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Modules Pages
Public Types | Public Member Functions | Friends | List of all members
spot::bitvect Class Reference

A bit vector. More...

`#include <spot/misc/bitvect.hh>`

Collaboration diagram for spot::bitvect:

## Public Types
typedef unsigned long | block_t

## Public Member Functions
| bitvect (const bitvect &other)
bitvect * | clone () const
void | make_empty ()
bitvect & | operator= (const bitvect &other)
void | reserve_blocks (size_t new_block_count)
size_t | used_blocks () const
void | push_back (bool val)
| Append one bit. More...
void | push_back (block_t data, unsigned count)
| Append the lowest count bits of data. More...
size_t | size () const
size_t | capacity () const
size_t | hash () const
bool | get (size_t pos) const
void | clear_all ()
bool | is_fully_clear () const
bool | is_fully_set () const
void | set_all ()
void | flip_all ()
void | set (size_t pos)
void | clear (size_t pos)
void | flip (size_t pos)
bitvect & | operator|= (const bitvect &other)
bitvect & | operator&= (const bitvect &other)
bitvect & | operator^= (const bitvect &other)
bitvect & | operator-= (const bitvect &other)
bool | is_subset_of (const bitvect &other) const
bool | operator== (const bitvect &other) const
bool | operator!= (const bitvect &other) const
bool | operator< (const bitvect &other) const
bool | operator>= (const bitvect &other) const
bool | operator> (const bitvect &other) const
bool | operator<= (const bitvect &other) const
bitvect * | extract_range (size_t begin, size_t end)

## Friends
bitvect * | make_bitvect (size_t bitcount)
| Allocate a bit-vector of bitcount bits. More...
std::ostream & | operator<< (std::ostream &, const bitvect &)
| Print a bitvect. More...
bitvect_array * | make_bitvect_array (size_t bitcount, size_t vectcount)
| Allocate vectcount bit-vectors of bitcount bits. More...

## Detailed Description

A bit vector.

## Member Function Documentation

void spot::bitvect::push_back | ( | bool | val | ) |
| inline

Append one bit.

void spot::bitvect::push_back | ( | block_t | data,
|  | unsigned | count
| ) |  |
| inline

Append the lowest count bits of data.

void spot::bitvect::reserve_blocks | ( | size_t | new_block_count | ) |
| inline

Grow the bitvector to new_block_count blocks.

This only changes the capacity of the bitvector, not its size.

## Friends And Related Function Documentation

bitvect* make_bitvect | ( | size_t | bitcount | ) |
| friend

Allocate a bit-vector of bitcount bits.

The resulting object should be released with `delete`.

bitvect_array* make_bitvect_array | ( | size_t | bitcount,
|  | size_t | vectcount
| ) |  |
| friend

Allocate vectcount bit-vectors of bitcount bits.

The resulting bitvect_array should be released with `delete`.

std::ostream& operator<< | ( | std::ostream & | ,
|  | const bitvect & |
| ) |  |
| friend

Print a bitvect.

The documentation for this class was generated from the following file:

- spot/misc/bitvect.hh

Please direct any question, comment, or bug report to the Spot mailing list at spot@lrde.epita.fr.